summaryrefslogtreecommitdiffstats
path: root/misc
diff options
context:
space:
mode:
authorThaddeus Crews <repiteo@outlook.com>2024-06-24 12:20:55 -0500
committerThaddeus Crews <repiteo@outlook.com>2024-06-24 15:43:55 -0500
commite0d363aad8e2204fe8ca4b6937ef2ad74a7b293b (patch)
treec8300e4864984e9157ba8502ee019c4cd7226128 /misc
parentc414c2b37d0563456a2fe194b16f8c4aa442e865 (diff)
downloadredot-cpp-e0d363aad8e2204fe8ca4b6937ef2ad74a7b293b.tar.gz
Integrate `.pre-commit-config.yaml`
Diffstat (limited to 'misc')
-rw-r--r--misc/hooks/README.md37
-rwxr-xr-xmisc/hooks/canonicalize_filename.sh48
-rwxr-xr-xmisc/hooks/pre-commit50
-rwxr-xr-xmisc/hooks/pre-commit-black202
-rwxr-xr-xmisc/hooks/pre-commit-clang-format242
-rw-r--r--misc/hooks/winmessage.ps1103
-rwxr-xr-xmisc/scripts/black_format.sh25
-rwxr-xr-xmisc/scripts/check_ci_log.py6
-rwxr-xr-xmisc/scripts/check_get_file_list.py6
-rwxr-xr-xmisc/scripts/clang_format.sh38
-rw-r--r--misc/scripts/codespell.sh5
-rwxr-xr-xmisc/scripts/copyright_headers.py99
-rw-r--r--misc/scripts/file_format.py46
-rwxr-xr-xmisc/scripts/file_format.sh41
-rw-r--r--misc/scripts/header_guards.py127
-rwxr-xr-xmisc/scripts/header_guards.sh60
-rw-r--r--misc/scripts/mypy.ini11
-rwxr-xr-xmisc/scripts/mypy_check.sh6
18 files changed, 230 insertions, 922 deletions
diff --git a/misc/hooks/README.md b/misc/hooks/README.md
deleted file mode 100644
index 8732237..0000000
--- a/misc/hooks/README.md
+++ /dev/null
@@ -1,37 +0,0 @@
-# Git hooks for Godot Engine
-
-This folder contains Git hooks meant to be installed locally by Godot Engine
-contributors to make sure they comply with our requirements.
-
-## List of hooks
-
-- Pre-commit hook for `clang-format`: Applies `clang-format` to the staged
- files before accepting a commit; blocks the commit and generates a patch if
- the style is not respected.
- You may need to edit the file if your `clang-format` binary is not in the
- `PATH`, or if you want to enable colored output with `pygmentize`.
-- Pre-commit hook for `black`: Applies `black` to the staged Python files
- before accepting a commit.
-- Pre-commit hook for `make_rst`: Checks the class reference syntax using
- `make_rst.py`.
-
-## Installation
-
-Copy all the files from this folder into your `.git/hooks` folder, and make
-sure the hooks and helper scripts are executable.
-
-#### Linux/MacOS
-
-The hooks rely on bash scripts and tools which should be in the system `PATH`,
-so they should work out of the box on Linux/macOS.
-
-#### Windows
-
-##### clang-format
-- Download LLVM for Windows (version 13 or later) from
- <https://releases.llvm.org/download.html>
-- Make sure LLVM is added to the `PATH` during installation
-
-##### black
-- Python installation: make sure Python is added to the `PATH`
-- Install `black` - in any console: `pip3 install black`
diff --git a/misc/hooks/canonicalize_filename.sh b/misc/hooks/canonicalize_filename.sh
deleted file mode 100755
index fe66999..0000000
--- a/misc/hooks/canonicalize_filename.sh
+++ /dev/null
@@ -1,48 +0,0 @@
-#!/bin/sh
-
-# Provide the canonicalize filename (physical filename with out any symlinks)
-# like the GNU version readlink with the -f option regardless of the version of
-# readlink (GNU or BSD).
-
-# This file is part of a set of unofficial pre-commit hooks available
-# at github.
-# Link: https://github.com/githubbrowser/Pre-commit-hooks
-# Contact: David Martin, david.martin.mailbox@googlemail.com
-
-###########################################################
-# There should be no need to change anything below this line.
-
-# Canonicalize by recursively following every symlink in every component of the
-# specified filename. This should reproduce the results of the GNU version of
-# readlink with the -f option.
-#
-# Reference: https://stackoverflow.com/questions/1055671/how-can-i-get-the-behavior-of-gnus-readlink-f-on-a-mac
-canonicalize_filename () {
- local target_file="$1"
- local physical_directory=""
- local result=""
-
- # Need to restore the working directory after work.
- local working_dir="`pwd`"
-
- cd -- "$(dirname -- "$target_file")"
- target_file="$(basename -- "$target_file")"
-
- # Iterate down a (possible) chain of symlinks
- while [ -L "$target_file" ]
- do
- target_file="$(readlink -- "$target_file")"
- cd -- "$(dirname -- "$target_file")"
- target_file="$(basename -- "$target_file")"
- done
-
- # Compute the canonicalized name by finding the physical path
- # for the directory we're in and appending the target file.
- physical_directory="`pwd -P`"
- result="$physical_directory/$target_file"
-
- # restore the working directory after work.
- cd -- "$working_dir"
-
- echo "$result"
-}
diff --git a/misc/hooks/pre-commit b/misc/hooks/pre-commit
deleted file mode 100755
index 1d71370..0000000
--- a/misc/hooks/pre-commit
+++ /dev/null
@@ -1,50 +0,0 @@
-#!/bin/sh
-# Git pre-commit hook that runs multiple hooks specified in $HOOKS.
-# Make sure this script is executable. Bypass hooks with git commit --no-verify.
-
-# This file is part of a set of unofficial pre-commit hooks available
-# at github.
-# Link: https://github.com/githubbrowser/Pre-commit-hooks
-# Contact: David Martin, david.martin.mailbox@googlemail.com
-
-
-###########################################################
-# CONFIGURATION:
-# pre-commit hooks to be executed. They should be in the same .git/hooks/ folder
-# as this script. Hooks should return 0 if successful and nonzero to cancel the
-# commit. They are executed in the order in which they are listed.
-#HOOKS="pre-commit-compile pre-commit-uncrustify"
-HOOKS="pre-commit-clang-format pre-commit-black"
-###########################################################
-# There should be no need to change anything below this line.
-
-. "$(dirname -- "$0")/canonicalize_filename.sh"
-
-# exit on error
-set -e
-
-# Absolute path to this script, e.g. /home/user/bin/foo.sh
-SCRIPT="$(canonicalize_filename "$0")"
-
-# Absolute path this script is in, thus /home/user/bin
-SCRIPTPATH="$(dirname -- "$SCRIPT")"
-
-
-for hook in $HOOKS
-do
- echo "Running hook: $hook"
- # run hook if it exists
- # if it returns with nonzero exit with 1 and thus abort the commit
- if [ -f "$SCRIPTPATH/$hook" ]; then
- "$SCRIPTPATH/$hook"
- if [ $? != 0 ]; then
- exit 1
- fi
- else
- echo "Error: file $hook not found."
- echo "Aborting commit. Make sure the hook is in $SCRIPTPATH and executable."
- echo "You can disable it by removing it from the list in $SCRIPT."
- echo "You can skip all pre-commit hooks with --no-verify (not recommended)."
- exit 1
- fi
-done
diff --git a/misc/hooks/pre-commit-black b/misc/hooks/pre-commit-black
deleted file mode 100755
index fd93bfe..0000000
--- a/misc/hooks/pre-commit-black
+++ /dev/null
@@ -1,202 +0,0 @@
-#!/usr/bin/env bash
-
-# git pre-commit hook that runs a black stylecheck.
-# Based on pre-commit-clang-format.
-
-##################################################################
-# SETTINGS
-# Set path to black binary.
-BLACK=`which black 2>/dev/null`
-BLACK_OPTIONS="-l 120"
-
-# Remove any older patches from previous commits. Set to true or false.
-DELETE_OLD_PATCHES=false
-
-# File types to parse.
-FILE_NAMES="SConstruct SCsub"
-FILE_EXTS=".py"
-
-# Use pygmentize instead of cat to parse diff with highlighting.
-# Install it with `pip install pygments` (Linux) or `easy_install Pygments` (Mac)
-PYGMENTIZE=`which pygmentize 2>/dev/null`
-if [ ! -z "$PYGMENTIZE" ]; then
- READER="pygmentize -l diff"
-else
- READER=cat
-fi
-
-# Path to zenity
-ZENITY=`which zenity 2>/dev/null`
-
-# Path to xmessage
-XMSG=`which xmessage 2>/dev/null`
-
-# Path to powershell (Windows only)
-PWSH=`which powershell 2>/dev/null`
-
-##################################################################
-# There should be no need to change anything below this line.
-
-. "$(dirname -- "$0")/canonicalize_filename.sh"
-
-# exit on error
-set -e
-
-# check whether the given file matches any of the set extensions
-matches_name_or_extension() {
- local filename=$(basename "$1")
- local extension=".${filename##*.}"
-
- for name in $FILE_NAMES; do [[ "$name" == "$filename" ]] && return 0; done
- for ext in $FILE_EXTS; do [[ "$ext" == "$extension" ]] && return 0; done
-
- return 1
-}
-
-# necessary check for initial commit
-if git rev-parse --verify HEAD >/dev/null 2>&1 ; then
- against=HEAD
-else
- # Initial commit: diff against an empty tree object
- against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
-fi
-
-if [ ! -x "$BLACK" ] ; then
- if [ ! -t 1 ] ; then
- if [ -x "$ZENITY" ] ; then
- $ZENITY --error --title="Error" --text="Error: black executable not found."
- exit 1
- elif [ -x "$XMSG" ] ; then
- $XMSG -center -title "Error" "Error: black executable not found."
- exit 1
- elif [ \( \( "$OSTYPE" = "msys" \) -o \( "$OSTYPE" = "win32" \) \) -a \( -x "$PWSH" \) ]; then
- winmessage="$(canonicalize_filename "./.git/hooks/winmessage.ps1")"
- $PWSH -noprofile -executionpolicy bypass -file "$winmessage" -center -title "Error" --text "Error: black executable not found."
- exit 1
- fi
- fi
- printf "Error: black executable not found.\n"
- printf "Set the correct path in $(canonicalize_filename "$0").\n"
- exit 1
-fi
-
-# create a random filename to store our generated patch
-prefix="pre-commit-black"
-suffix="$(date +%s)"
-patch="/tmp/$prefix-$suffix.patch"
-
-# clean up any older black patches
-$DELETE_OLD_PATCHES && rm -f /tmp/$prefix*.patch
-
-# create one patch containing all changes to the files
-git diff-index --cached --diff-filter=ACMR --name-only $against -- | while read file;
-do
- # ignore thirdparty files
- if grep -q "thirdparty" <<< $file; then
- continue;
- fi
-
- # ignore file if not one of the names or extensions we handle
- if ! matches_name_or_extension "$file"; then
- continue;
- fi
-
- # format our file with black, create a patch with diff and append it to our $patch
- # The sed call is necessary to transform the patch from
- # --- $file timestamp
- # +++ $file timestamp
- # to both lines working on the same file and having a/ and b/ prefix.
- # Else it can not be applied with 'git apply'.
- "$BLACK" "$BLACK_OPTIONS" --diff "$file" | \
- sed -e "1s|--- |--- a/|" -e "2s|+++ |+++ b/|" >> "$patch"
-done
-
-# if no patch has been generated all is ok, clean up the file stub and exit
-if [ ! -s "$patch" ] ; then
- printf "Files in this commit comply with the black formatter rules.\n"
- rm -f "$patch"
- exit 0
-fi
-
-# a patch has been created, notify the user and exit
-printf "\nThe following differences were found between the code to commit "
-printf "and the black formatter rules:\n\n"
-
-if [ -t 1 ] ; then
- $READER "$patch"
- printf "\n"
- # Allows us to read user input below, assigns stdin to keyboard
- exec < /dev/tty
- terminal="1"
-else
- cat "$patch"
- printf "\n"
- # Allows non zero zenity/powershell output
- set +e
- terminal="0"
-fi
-
-while true; do
- if [ $terminal = "0" ] ; then
- if [ -x "$ZENITY" ] ; then
- choice=$($ZENITY --text-info --filename="$patch" --width=800 --height=600 --title="Do you want to apply that patch?" --ok-label="Apply" --cancel-label="Do not apply" --extra-button="Apply and stage")
- if [ "$?" = "0" ] ; then
- yn="Y"
- else
- if [ "$choice" = "Apply and stage" ] ; then
- yn="S"
- else
- yn="N"
- fi
- fi
- elif [ -x "$XMSG" ] ; then
- $XMSG -file "$patch" -buttons "Apply":100,"Apply and stage":200,"Do not apply":0 -center -default "Do not apply" -geometry 800x600 -title "Do you want to apply that patch?"
- choice=$?
- if [ "$choice" = "100" ] ; then
- yn="Y"
- elif [ "$choice" = "200" ] ; then
- yn="S"
- else
- yn="N"
- fi
- elif [ \( \( "$OSTYPE" = "msys" \) -o \( "$OSTYPE" = "win32" \) \) -a \( -x "$PWSH" \) ]; then
- winmessage="$(canonicalize_filename "./.git/hooks/winmessage.ps1")"
- $PWSH -noprofile -executionpolicy bypass -file "$winmessage" -file "$patch" -buttons "Apply":100,"Apply and stage":200,"Do not apply":0 -center -default "Do not apply" -geometry 800x600 -title "Do you want to apply that patch?"
- choice=$?
- if [ "$choice" = "100" ] ; then
- yn="Y"
- elif [ "$choice" = "200" ] ; then
- yn="S"
- else
- yn="N"
- fi
- else
- printf "Error: zenity, xmessage, or powershell executable not found.\n"
- exit 1
- fi
- else
- read -p "Do you want to apply that patch (Y - Apply, N - Do not apply, S - Apply and stage files)? [Y/N/S] " yn
- fi
- case $yn in
- [Yy] ) git apply $patch;
- printf "The patch was applied. You can now stage the changes and commit again.\n\n";
- break
- ;;
- [Nn] ) printf "\nYou can apply these changes with:\n git apply $patch\n";
- printf "(may need to be called from the root directory of your repository)\n";
- printf "Aborting commit. Apply changes and commit again or skip checking with";
- printf " --no-verify (not recommended).\n\n";
- break
- ;;
- [Ss] ) git apply $patch;
- git diff-index --cached --diff-filter=ACMR --name-only $against -- | while read file;
- do git add $file;
- done
- printf "The patch was applied and the changed files staged. You can now commit.\n\n";
- break
- ;;
- * ) echo "Please answer yes or no."
- ;;
- esac
-done
-exit 1 # we don't commit in any case
diff --git a/misc/hooks/pre-commit-clang-format b/misc/hooks/pre-commit-clang-format
deleted file mode 100755
index 2ee3f56..0000000
--- a/misc/hooks/pre-commit-clang-format
+++ /dev/null
@@ -1,242 +0,0 @@
-#!/usr/bin/env bash
-
-# git pre-commit hook that runs a clang-format stylecheck.
-# Features:
-# - abort commit when commit does not comply with the style guidelines
-# - create a patch of the proposed style changes
-# Modifications for clang-format by rene.milk@wwu.de
-
-# This file is part of a set of unofficial pre-commit hooks available
-# at github.
-# Link: https://github.com/githubbrowser/Pre-commit-hooks
-# Contact: David Martin, david.martin.mailbox@googlemail.com
-
-# Some quality of life modifications made for Godot Engine.
-
-##################################################################
-# SETTINGS
-# Set path to clang-format binary.
-CLANG_FORMAT=`which clang-format 2>/dev/null`
-
-# Remove any older patches from previous commits. Set to true or false.
-DELETE_OLD_PATCHES=false
-
-# Only parse files with the extensions in FILE_EXTS. Set to true or false.
-# If false every changed file in the commit will be parsed with clang-format.
-# If true only files matching one of the extensions are parsed with clang-format.
-PARSE_EXTS=true
-
-# File types to parse. Only effective when PARSE_EXTS is true.
-FILE_EXTS=".c .h .cpp .hpp .cc .hh .cxx .m .mm .inc .java .glsl"
-
-# Use pygmentize instead of cat to parse diff with highlighting.
-# Install it with `pip install pygments` (Linux) or `easy_install Pygments` (Mac)
-PYGMENTIZE=`which pygmentize 2>/dev/null`
-if [ ! -z "$PYGMENTIZE" ]; then
- READER="pygmentize -l diff"
-else
- READER=cat
-fi
-
-# Path to zenity
-ZENITY=`which zenity 2>/dev/null`
-
-# Path to xmessage
-XMSG=`which xmessage 2>/dev/null`
-
-# Path to powershell (Windows only)
-PWSH=`which powershell 2>/dev/null`
-
-##################################################################
-# There should be no need to change anything below this line.
-
-. "$(dirname -- "$0")/canonicalize_filename.sh"
-
-# exit on error
-set -e
-
-# check whether the given file matches any of the set extensions
-matches_extension() {
- local filename=$(basename "$1")
- local extension=".${filename##*.}"
- local ext
-
- for ext in $FILE_EXTS; do [[ "$ext" == "$extension" ]] && return 0; done
-
- return 1
-}
-
-# necessary check for initial commit
-if git rev-parse --verify HEAD >/dev/null 2>&1 ; then
- against=HEAD
-else
- # Initial commit: diff against an empty tree object
- against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
-fi
-
-# To get consistent formatting, we recommend contributors to use the same
-# clang-format version as CI.
-RECOMMENDED_CLANG_FORMAT_MAJOR_MIN="12"
-RECOMMENDED_CLANG_FORMAT_MAJOR_MAX="13"
-
-if [ ! -x "$CLANG_FORMAT" ] ; then
- message="Error: clang-format executable not found. Please install clang-format $RECOMMENDED_CLANG_FORMAT_MAJOR_MAX."
-
- if [ ! -t 1 ] ; then
- if [ -x "$ZENITY" ] ; then
- $ZENITY --error --title="Error" --text="$message"
- exit 1
- elif [ -x "$XMSG" ] ; then
- $XMSG -center -title "Error" "$message"
- exit 1
- elif [ \( \( "$OSTYPE" = "msys" \) -o \( "$OSTYPE" = "win32" \) \) -a \( -x "$PWSH" \) ]; then
- winmessage="$(canonicalize_filename "./.git/hooks/winmessage.ps1")"
- $PWSH -noprofile -executionpolicy bypass -file "$winmessage" -center -title "Error" --text "$message"
- exit 1
- fi
- fi
- printf "$message\n"
- printf "Set the correct path in $(canonicalize_filename "$0").\n"
- exit 1
-fi
-
-# The returned string can be inconsistent depending on where clang-format comes from.
-# Example output strings reported by `clang-format --version`:
-# - Ubuntu: "Ubuntu clang-format version 11.0.0-2"
-# - Fedora: "clang-format version 11.0.0 (Fedora 11.0.0-2.fc33)"
-CLANG_FORMAT_VERSION="$(clang-format --version | sed "s/[^0-9\.]*\([0-9\.]*\).*/\1/")"
-CLANG_FORMAT_MAJOR="$(echo "$CLANG_FORMAT_VERSION" | cut -d. -f1)"
-
-if [[ "$CLANG_FORMAT_MAJOR" -lt "$RECOMMENDED_CLANG_FORMAT_MAJOR_MIN" || "$CLANG_FORMAT_MAJOR" -gt "$RECOMMENDED_CLANG_FORMAT_MAJOR_MAX" ]]; then
- echo "Warning: Your clang-format binary is the wrong version ($CLANG_FORMAT_VERSION, expected between $RECOMMENDED_CLANG_FORMAT_MAJOR_MIN and $RECOMMENDED_CLANG_FORMAT_MAJOR_MAX)."
- echo " Consider upgrading or downgrading clang-format as formatting may not be applied correctly."
-fi
-
-# create a random filename to store our generated patch
-prefix="pre-commit-clang-format"
-suffix="$(date +%s)"
-patch="/tmp/$prefix-$suffix.patch"
-
-# clean up any older clang-format patches
-$DELETE_OLD_PATCHES && rm -f /tmp/$prefix*.patch
-
-# create one patch containing all changes to the files
-git diff-index --cached --diff-filter=ACMR --name-only $against -- | while read file;
-do
- # ignore thirdparty files
- if grep -q "thirdparty" <<< $file; then
- continue;
- fi
- if grep -q "platform/android/java/lib/src/com" <<< $file; then
- continue;
- fi
- if grep -q "\-so_wrap." <<< $file; then
- continue;
- fi
-
- # ignore file if we do check for file extensions and the file
- # does not match any of the extensions specified in $FILE_EXTS
- if $PARSE_EXTS && ! matches_extension "$file"; then
- continue;
- fi
-
- # clang-format our sourcefile, create a patch with diff and append it to our $patch
- # The sed call is necessary to transform the patch from
- # --- $file timestamp
- # +++ - timestamp
- # to both lines working on the same file and having a/ and b/ prefix.
- # Else it can not be applied with 'git apply'.
- "$CLANG_FORMAT" -style=file "$file" --Wno-error=unknown | \
- diff -u "$file" - | \
- sed -e "1s|--- |--- a/|" -e "2s|+++ -|+++ b/$file|" >> "$patch"
-done
-
-# if no patch has been generated all is ok, clean up the file stub and exit
-if [ ! -s "$patch" ] ; then
- printf "Files in this commit comply with the clang-format rules.\n"
- rm -f "$patch"
- exit 0
-fi
-
-# a patch has been created, notify the user and exit
-printf "\nThe following differences were found between the code to commit "
-printf "and the clang-format rules:\n\n"
-
-if [ -t 1 ] ; then
- $READER "$patch"
- printf "\n"
- # Allows us to read user input below, assigns stdin to keyboard
- exec < /dev/tty
- terminal="1"
-else
- cat "$patch"
- printf "\n"
- # Allows non zero zenity/powershell output
- set +e
- terminal="0"
-fi
-
-while true; do
- if [ $terminal = "0" ] ; then
- if [ -x "$ZENITY" ] ; then
- choice=$($ZENITY --text-info --filename="$patch" --width=800 --height=600 --title="Do you want to apply that patch?" --ok-label="Apply" --cancel-label="Do not apply" --extra-button="Apply and stage")
- if [ "$?" = "0" ] ; then
- yn="Y"
- else
- if [ "$choice" = "Apply and stage" ] ; then
- yn="S"
- else
- yn="N"
- fi
- fi
- elif [ -x "$XMSG" ] ; then
- $XMSG -file "$patch" -buttons "Apply":100,"Apply and stage":200,"Do not apply":0 -center -default "Do not apply" -geometry 800x600 -title "Do you want to apply that patch?"
- choice=$?
- if [ "$choice" = "100" ] ; then
- yn="Y"
- elif [ "$choice" = "200" ] ; then
- yn="S"
- else
- yn="N"
- fi
- elif [ \( \( "$OSTYPE" = "msys" \) -o \( "$OSTYPE" = "win32" \) \) -a \( -x "$PWSH" \) ]; then
- winmessage="$(canonicalize_filename "./.git/hooks/winmessage.ps1")"
- $PWSH -noprofile -executionpolicy bypass -file "$winmessage" -file "$patch" -buttons "Apply":100,"Apply and stage":200,"Do not apply":0 -center -default "Do not apply" -geometry 800x600 -title "Do you want to apply that patch?"
- choice=$?
- if [ "$choice" = "100" ] ; then
- yn="Y"
- elif [ "$choice" = "200" ] ; then
- yn="S"
- else
- yn="N"
- fi
- else
- printf "Error: zenity, xmessage, or powershell executable not found.\n"
- exit 1
- fi
- else
- read -p "Do you want to apply that patch (Y - Apply, N - Do not apply, S - Apply and stage files)? [Y/N/S] " yn
- fi
- case $yn in
- [Yy] ) git apply $patch;
- printf "The patch was applied. You can now stage the changes and commit again.\n\n";
- break
- ;;
- [Nn] ) printf "\nYou can apply these changes with:\n git apply $patch\n";
- printf "(may need to be called from the root directory of your repository)\n";
- printf "Aborting commit. Apply changes and commit again or skip checking with";
- printf " --no-verify (not recommended).\n\n";
- break
- ;;
- [Ss] ) git apply $patch;
- git diff-index --cached --diff-filter=ACMR --name-only $against -- | while read file;
- do git add $file;
- done
- printf "The patch was applied and the changed files staged. You can now commit.\n\n";
- break
- ;;
- * ) echo "Please answer yes or no."
- ;;
- esac
-done
-exit 1 # we don't commit in any case
diff --git a/misc/hooks/winmessage.ps1 b/misc/hooks/winmessage.ps1
deleted file mode 100644
index 3672579..0000000
--- a/misc/hooks/winmessage.ps1
+++ /dev/null
@@ -1,103 +0,0 @@
-Param (
- [string]$file = "",
- [string]$text = "",
- [string]$buttons = "OK:0",
- [string]$default = "",
- [switch]$nearmouse = $false,
- [switch]$center = $false,
- [string]$geometry = "",
- [int32]$timeout = 0,
- [string]$title = "Message"
-)
-Add-Type -assembly System.Windows.Forms
-
-$global:Result = 0
-
-$main_form = New-Object System.Windows.Forms.Form
-$main_form.Text = $title
-
-$geometry_data = $geometry.Split("+")
-if ($geometry_data.Length -ge 1) {
- $size_data = $geometry_data[0].Split("x")
- if ($size_data.Length -eq 2) {
- $main_form.Width = $size_data[0]
- $main_form.Height = $size_data[1]
- }
-}
-if ($geometry_data.Length -eq 3) {
- $main_form.StartPosition = [System.Windows.Forms.FormStartPosition]::Manual
- $main_form.Location = New-Object System.Drawing.Point($geometry_data[1], $geometry_data[2])
-}
-if ($nearmouse) {
- $main_form.StartPosition = [System.Windows.Forms.FormStartPosition]::Manual
- $main_form.Location = System.Windows.Forms.Cursor.Position
-}
-if ($center) {
- $main_form.StartPosition = [System.Windows.Forms.FormStartPosition]::CenterScreen
-}
-
-$main_form.SuspendLayout()
-
-$button_panel = New-Object System.Windows.Forms.FlowLayoutPanel
-$button_panel.SuspendLayout()
-$button_panel.FlowDirection = [System.Windows.Forms.FlowDirection]::RightToLeft
-$button_panel.Dock = [System.Windows.Forms.DockStyle]::Bottom
-$button_panel.Autosize = $true
-
-if ($file -ne "") {
- $text = [IO.File]::ReadAllText($file).replace("`n", "`r`n")
-}
-
-if ($text -ne "") {
- $text_box = New-Object System.Windows.Forms.TextBox
- $text_box.Multiline = $true
- $text_box.ReadOnly = $true
- $text_box.Autosize = $true
- $text_box.Text = $text
- $text_box.Select(0,0)
- $text_box.Dock = [System.Windows.Forms.DockStyle]::Fill
- $main_form.Controls.Add($text_box)
-}
-
-$buttons_array = $buttons.Split(",")
-foreach ($button in $buttons_array) {
- $button_data = $button.Split(":")
- $button_ctl = New-Object System.Windows.Forms.Button
- if ($button_data.Length -eq 2) {
- $button_ctl.Tag = $button_data[1]
- } else {
- $button_ctl.Tag = 100 + $buttons_array.IndexOf($button)
- }
- if ($default -eq $button_data[0]) {
- $main_form.AcceptButton = $button_ctl
- }
- $button_ctl.Autosize = $true
- $button_ctl.Text = $button_data[0]
- $button_ctl.Add_Click(
- {
- Param($sender)
- $global:Result = $sender.Tag
- $main_form.Close()
- }
- )
- $button_panel.Controls.Add($button_ctl)
-}
-$main_form.Controls.Add($button_panel)
-
-$button_panel.ResumeLayout($false)
-$main_form.ResumeLayout($false)
-
-if ($timeout -gt 0) {
- $timer = New-Object System.Windows.Forms.Timer
- $timer.Add_Tick(
- {
- $global:Result = 0
- $main_form.Close()
- }
- )
- $timer.Interval = $timeout
- $timer.Start()
-}
-$dlg_res = $main_form.ShowDialog()
-
-[Environment]::Exit($global:Result)
diff --git a/misc/scripts/black_format.sh b/misc/scripts/black_format.sh
deleted file mode 100755
index 99343f1..0000000
--- a/misc/scripts/black_format.sh
+++ /dev/null
@@ -1,25 +0,0 @@
-#!/usr/bin/env bash
-
-# This script runs black on all Python files in the repo.
-
-set -uo pipefail
-
-# Apply black.
-echo -e "Formatting Python files..."
-PY_FILES=$(git ls-files -- '*SConstruct' '*SCsub' '*.py' ':!:.git/*' ':!:thirdparty/*')
-black -l 120 $PY_FILES
-
-diff=$(git diff --color)
-
-# If no patch has been generated all is OK, clean up, and exit.
-if [ -z "$diff" ] ; then
- printf "Files in this commit comply with the black style rules.\n"
- exit 0
-fi
-
-# A patch has been created, notify the user, clean up, and exit.
-printf "\n*** The following differences were found between the code "
-printf "and the formatting rules:\n\n"
-echo "$diff"
-printf "\n*** Aborting, please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
-exit 1
diff --git a/misc/scripts/check_ci_log.py b/misc/scripts/check_ci_log.py
index 2c75b83..d024a3e 100755
--- a/misc/scripts/check_ci_log.py
+++ b/misc/scripts/check_ci_log.py
@@ -9,8 +9,8 @@ if len(sys.argv) < 2:
fname = sys.argv[1]
-fileread = open(fname.strip(), "r")
-file_contents = fileread.read()
+with open(fname.strip(), "r", encoding="utf-8") as fileread:
+ file_contents = fileread.read()
# If find "ERROR: AddressSanitizer:", then happens invalid read or write
# This is critical bug, so we need to fix this as fast as possible
@@ -25,6 +25,8 @@ if (
file_contents.find("Program crashed with signal") != -1
or file_contents.find("Dumping the backtrace") != -1
or file_contents.find("Segmentation fault (core dumped)") != -1
+ or file_contents.find("Aborted (core dumped)") != -1
+ or file_contents.find("terminate called without an active exception") != -1
):
print("FATAL ERROR: Godot has been crashed.")
sys.exit(52)
diff --git a/misc/scripts/check_get_file_list.py b/misc/scripts/check_get_file_list.py
index d536a7a..33bc6b6 100755
--- a/misc/scripts/check_get_file_list.py
+++ b/misc/scripts/check_get_file_list.py
@@ -1,12 +1,12 @@
#!/usr/bin/env python
-import os, sys
-
+import os
+import sys
from pathlib import Path
sys.path.insert(1, os.path.join(os.path.dirname(__file__), "..", ".."))
-from binding_generator import get_file_list, generate_bindings
+from binding_generator import generate_bindings, get_file_list
api_filepath = "gdextension/extension_api.json"
bits = "64"
diff --git a/misc/scripts/clang_format.sh b/misc/scripts/clang_format.sh
deleted file mode 100755
index a5c07b9..0000000
--- a/misc/scripts/clang_format.sh
+++ /dev/null
@@ -1,38 +0,0 @@
-#!/usr/bin/env bash
-
-# This script runs clang-format and fixes copyright headers on all relevant files in the repo.
-# This is the primary script responsible for fixing style violations.
-
-set -uo pipefail
-
-# Loops through all code files tracked by Git.
-git ls-files -- '*.c' '*.h' '*.cpp' '*.hpp' '*.cc' '*.hh' '*.cxx' '*.m' '*.mm' '*.inc' |
-while read -r f; do
- # Run clang-format.
- clang-format --Wno-error=unknown -i "$f"
-
- # Fix copyright headers, but not all files get them.
- if [[ "$f" == *"inc" ]]; then
- continue
- elif [[ "$f" == *"glsl" ]]; then
- continue
- elif [[ "$f" == "test/"* ]]; then
- continue
- fi
-
- python misc/scripts/copyright_headers.py "$f"
-done
-
-diff=$(git diff --color)
-
-# If no patch has been generated all is OK, clean up, and exit.
-if [ -z "$diff" ] ; then
- printf "Files in this commit comply with the clang-tidy style rules.\n"
- exit 0
-fi
-
-# A patch has been created, notify the user, clean up, and exit.
-printf "\n*** The following changes have been made to comply with the formatting rules:\n\n"
-echo "$diff"
-printf "\n*** Please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
-exit 1
diff --git a/misc/scripts/codespell.sh b/misc/scripts/codespell.sh
deleted file mode 100644
index 2822c64..0000000
--- a/misc/scripts/codespell.sh
+++ /dev/null
@@ -1,5 +0,0 @@
-#!/bin/sh
-SKIP_LIST="./thirdparty,*.gen.*,*.po,*.pot,package-lock.json,./core/string/locales.h,./DONORS.md,./misc/scripts/codespell.sh"
-IGNORE_LIST="ba,childs,curvelinear,expct,fave,findn,gird,inout,lod,nd,numer,ois,ro,statics,te,varn"
-
-codespell -w -q 3 -S "${SKIP_LIST}" -L "${IGNORE_LIST}"
diff --git a/misc/scripts/copyright_headers.py b/misc/scripts/copyright_headers.py
index a5e2f0c..2b1201b 100755
--- a/misc/scripts/copyright_headers.py
+++ b/misc/scripts/copyright_headers.py
@@ -1,6 +1,7 @@
#!/usr/bin/env python
# -*- coding: utf-8 -*-
+import os
import sys
header = """\
@@ -35,61 +36,61 @@ header = """\
/**************************************************************************/
"""
-fname = sys.argv[1]
+if len(sys.argv) < 2:
+ print("Invalid usage of copyright_headers.py, it should be called with a path to one or multiple files.")
+ sys.exit(1)
-# Handle replacing $filename with actual filename and keep alignment
-fsingle = fname.strip()
-if fsingle.find("/") != -1:
- fsingle = fsingle[fsingle.rfind("/") + 1 :]
-rep_fl = "$filename"
-rep_fi = fsingle
-len_fl = len(rep_fl)
-len_fi = len(rep_fi)
-# Pad with spaces to keep alignment
-if len_fi < len_fl:
- for x in range(len_fl - len_fi):
- rep_fi += " "
-elif len_fl < len_fi:
- for x in range(len_fi - len_fl):
- rep_fl += " "
-if header.find(rep_fl) != -1:
- text = header.replace(rep_fl, rep_fi)
-else:
- text = header.replace("$filename", fsingle)
-text += "\n"
+for f in sys.argv[1:]:
+ fname = f
-# We now have the proper header, so we want to ignore the one in the original file
-# and potentially empty lines and badly formatted lines, while keeping comments that
-# come after the header, and then keep everything non-header unchanged.
-# To do so, we skip empty lines that may be at the top in a first pass.
-# In a second pass, we skip all consecutive comment lines starting with "/*",
-# then we can append the rest (step 2).
+ # Handle replacing $filename with actual filename and keep alignment
+ fsingle = os.path.basename(fname.strip())
+ rep_fl = "$filename"
+ rep_fi = fsingle
+ len_fl = len(rep_fl)
+ len_fi = len(rep_fi)
+ # Pad with spaces to keep alignment
+ if len_fi < len_fl:
+ for x in range(len_fl - len_fi):
+ rep_fi += " "
+ elif len_fl < len_fi:
+ for x in range(len_fi - len_fl):
+ rep_fl += " "
+ if header.find(rep_fl) != -1:
+ text = header.replace(rep_fl, rep_fi)
+ else:
+ text = header.replace("$filename", fsingle)
+ text += "\n"
-fileread = open(fname.strip(), "r")
-line = fileread.readline()
-header_done = False
+ # We now have the proper header, so we want to ignore the one in the original file
+ # and potentially empty lines and badly formatted lines, while keeping comments that
+ # come after the header, and then keep everything non-header unchanged.
+ # To do so, we skip empty lines that may be at the top in a first pass.
+ # In a second pass, we skip all consecutive comment lines starting with "/*",
+ # then we can append the rest (step 2).
-while line.strip() == "": # Skip empty lines at the top
- line = fileread.readline()
+ with open(fname.strip(), "r", encoding="utf-8") as fileread:
+ line = fileread.readline()
+ header_done = False
-if line.find("/**********") == -1: # Godot header starts this way
- # Maybe starting with a non-Godot comment, abort header magic
- header_done = True
+ while line.strip() == "" and line != "": # Skip empty lines at the top
+ line = fileread.readline()
-while not header_done: # Handle header now
- if line.find("/*") != 0: # No more starting with a comment
- header_done = True
- if line.strip() != "":
- text += line
- line = fileread.readline()
+ if line.find("/**********") == -1: # Godot header starts this way
+ # Maybe starting with a non-Godot comment, abort header magic
+ header_done = True
-while line != "": # Dump everything until EOF
- text += line
- line = fileread.readline()
+ while not header_done: # Handle header now
+ if line.find("/*") != 0: # No more starting with a comment
+ header_done = True
+ if line.strip() != "":
+ text += line
+ line = fileread.readline()
-fileread.close()
+ while line != "": # Dump everything until EOF
+ text += line
+ line = fileread.readline()
-# Write
-filewrite = open(fname.strip(), "w")
-filewrite.write(text)
-filewrite.close()
+ # Write
+ with open(fname.strip(), "w", encoding="utf-8", newline="\n") as filewrite:
+ filewrite.write(text)
diff --git a/misc/scripts/file_format.py b/misc/scripts/file_format.py
new file mode 100644
index 0000000..2ca78be
--- /dev/null
+++ b/misc/scripts/file_format.py
@@ -0,0 +1,46 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+
+import sys
+
+if len(sys.argv) < 2:
+ print("Invalid usage of file_format.py, it should be called with a path to one or multiple files.")
+ sys.exit(1)
+
+BOM = b"\xef\xbb\xbf"
+
+changed = []
+invalid = []
+
+for file in sys.argv[1:]:
+ try:
+ with open(file, "rt", encoding="utf-8") as f:
+ original = f.read()
+ except UnicodeDecodeError:
+ invalid.append(file)
+ continue
+
+ if original == "":
+ continue
+
+ revamp = "\n".join([line.rstrip("\n\r\t ") for line in original.splitlines(True)]).rstrip("\n") + "\n"
+
+ new_raw = revamp.encode(encoding="utf-8")
+ if new_raw.startswith(BOM):
+ new_raw = new_raw[len(BOM) :]
+
+ with open(file, "rb") as f:
+ old_raw = f.read()
+
+ if old_raw != new_raw:
+ changed.append(file)
+ with open(file, "wb") as f:
+ f.write(new_raw)
+
+if changed:
+ for file in changed:
+ print(f"FIXED: {file}")
+if invalid:
+ for file in invalid:
+ print(f"REQUIRES MANUAL CHANGES: {file}")
+ sys.exit(1)
diff --git a/misc/scripts/file_format.sh b/misc/scripts/file_format.sh
deleted file mode 100755
index 6621af5..0000000
--- a/misc/scripts/file_format.sh
+++ /dev/null
@@ -1,41 +0,0 @@
-#!/usr/bin/env bash
-
-# This script ensures proper POSIX text file formatting and a few other things.
-# This is supplementary to clang_format.sh and black_format.sh, but should be
-# run before them.
-
-# We need dos2unix and recode.
-if [ ! -x "$(command -v dos2unix)" -o ! -x "$(command -v recode)" ]; then
- printf "Install 'dos2unix' and 'recode' to use this script.\n"
-fi
-
-set -uo pipefail
-IFS=$'\n\t'
-
-# Loops through all text files tracked by Git.
-git grep -zIl '' |
-while IFS= read -rd '' f; do
- # Ensure that files are UTF-8 formatted.
- recode UTF-8 "$f" 2> /dev/null
- # Ensure that files have LF line endings and do not contain a BOM.
- dos2unix "$f" 2> /dev/null
- # Remove trailing space characters and ensures that files end
- # with newline characters. -l option handles newlines conveniently.
- perl -i -ple 's/\s*$//g' "$f"
-done
-
-diff=$(git diff --color)
-
-# If no patch has been generated all is OK, clean up, and exit.
-if [ -z "$diff" ] ; then
- printf "Files in this commit comply with the formatting rules.\n"
- rm -f patch.patch
- exit 0
-fi
-
-# A patch has been created, notify the user, clean up, and exit.
-printf "\n*** The following differences were found between the code "
-printf "and the formatting rules:\n\n"
-echo "$diff"
-printf "\n*** Aborting, please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
-exit 1
diff --git a/misc/scripts/header_guards.py b/misc/scripts/header_guards.py
new file mode 100644
index 0000000..c99c422
--- /dev/null
+++ b/misc/scripts/header_guards.py
@@ -0,0 +1,127 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+
+import sys
+from pathlib import Path
+
+if len(sys.argv) < 2:
+ print("Invalid usage of header_guards.py, it should be called with a path to one or multiple files.")
+ sys.exit(1)
+
+HEADER_CHECK_OFFSET = 30
+HEADER_BEGIN_OFFSET = 31
+HEADER_END_OFFSET = -1
+
+changed = []
+invalid = []
+
+for file in sys.argv[1:]:
+ with open(file, "rt", encoding="utf-8", newline="\n") as f:
+ lines = f.readlines()
+
+ if len(lines) <= HEADER_BEGIN_OFFSET:
+ continue # Most likely a dummy file.
+
+ if lines[HEADER_CHECK_OFFSET].startswith("#import"):
+ continue # Early catch obj-c file.
+
+ name = f"GODOT_{Path(file).name}".upper().replace(".", "_").replace("-", "_").replace(" ", "_")
+
+ HEADER_CHECK = f"#ifndef {name}\n"
+ HEADER_BEGIN = f"#define {name}\n"
+ HEADER_END = f"#endif // {name}\n"
+
+ if (
+ lines[HEADER_CHECK_OFFSET] == HEADER_CHECK
+ and lines[HEADER_BEGIN_OFFSET] == HEADER_BEGIN
+ and lines[HEADER_END_OFFSET] == HEADER_END
+ ):
+ continue
+
+ # Guards might exist but with the wrong names.
+ if (
+ lines[HEADER_CHECK_OFFSET].startswith("#ifndef")
+ and lines[HEADER_BEGIN_OFFSET].startswith("#define")
+ and lines[HEADER_END_OFFSET].startswith("#endif")
+ ):
+ lines[HEADER_CHECK_OFFSET] = HEADER_CHECK
+ lines[HEADER_BEGIN_OFFSET] = HEADER_BEGIN
+ lines[HEADER_END_OFFSET] = HEADER_END
+ with open(file, "wt", encoding="utf-8", newline="\n") as f:
+ f.writelines(lines)
+ changed.append(file)
+ continue
+
+ header_check = -1
+ header_begin = -1
+ header_end = -1
+ pragma_once = -1
+ objc = False
+
+ for idx, line in enumerate(lines):
+ if not line.startswith("#"):
+ continue
+ elif line.startswith("#ifndef") and header_check == -1:
+ header_check = idx
+ elif line.startswith("#define") and header_begin == -1:
+ header_begin = idx
+ elif line.startswith("#endif") and header_end == -1:
+ header_end = idx
+ elif line.startswith("#pragma once"):
+ pragma_once = idx
+ break
+ elif line.startswith("#import"):
+ objc = True
+ break
+
+ if objc:
+ continue
+
+ if pragma_once != -1:
+ lines.pop(pragma_once)
+ lines.insert(HEADER_CHECK_OFFSET, HEADER_CHECK)
+ lines.insert(HEADER_BEGIN_OFFSET, HEADER_BEGIN)
+ lines.append("\n")
+ lines.append(HEADER_END)
+ with open(file, "wt", encoding="utf-8", newline="\n") as f:
+ f.writelines(lines)
+ changed.append(file)
+ continue
+
+ if header_check == -1 and header_begin == -1 and header_end == -1:
+ # Guards simply didn't exist
+ lines.insert(HEADER_CHECK_OFFSET, HEADER_CHECK)
+ lines.insert(HEADER_BEGIN_OFFSET, HEADER_BEGIN)
+ lines.append("\n")
+ lines.append(HEADER_END)
+ with open(file, "wt", encoding="utf-8", newline="\n") as f:
+ f.writelines(lines)
+ changed.append(file)
+ continue
+
+ if header_check != -1 and header_begin != -1 and header_end != -1:
+ # All prepends "found", see if we can salvage this.
+ if header_check == header_begin - 1 and header_begin < header_end:
+ lines.pop(header_check)
+ lines.pop(header_begin - 1)
+ lines.pop(header_end - 2)
+ if lines[header_end - 3] == "\n":
+ lines.pop(header_end - 3)
+ lines.insert(HEADER_CHECK_OFFSET, HEADER_CHECK)
+ lines.insert(HEADER_BEGIN_OFFSET, HEADER_BEGIN)
+ lines.append("\n")
+ lines.append(HEADER_END)
+ with open(file, "wt", encoding="utf-8", newline="\n") as f:
+ f.writelines(lines)
+ changed.append(file)
+ continue
+
+ invalid.append(file)
+
+if changed:
+ for file in changed:
+ print(f"FIXED: {file}")
+if invalid:
+ for file in invalid:
+ print(f"REQUIRES MANUAL CHANGES: {file}")
+ sys.exit(1)
diff --git a/misc/scripts/header_guards.sh b/misc/scripts/header_guards.sh
deleted file mode 100755
index 7cea339..0000000
--- a/misc/scripts/header_guards.sh
+++ /dev/null
@@ -1,60 +0,0 @@
-#!/bin/bash
-
-if [ ! -f "SConstruct" ]; then
- echo "Warning: This script is intended to be run from the root of the Godot repository."
- echo "Some of the paths checks may not work as intended from a different folder."
-fi
-
-files_invalid_guard=""
-
-for file in $(find . -name "*.hpp" -print); do
- # Skip generated files.
- if [[ "$file" == "./gen/"* || "$file" == "./include/gen/"* ]]; then continue; fi
- # Skip the test project.
- if [[ "$file" == "./test/"* ]]; then continue; fi
-
- bname=$(basename $file .hpp)
-
- # NOTE: The "GODOT_CPP_" prefix is already used by the generated
- # bindings, so we can't use that. We'll use "GODOT_" instead.
- prefix="GODOT_"
-
- # ^^ is bash builtin for UPPERCASE.
- guard="${prefix}${bname^^}_HPP"
-
- # Replaces guards to use computed name.
- # We also add some \n to make sure there's a proper separation.
- sed -i $file -e "0,/ifndef/s/#ifndef.*/\n#ifndef $guard/"
- sed -i $file -e "0,/define/s/#define.*/#define $guard\n/"
- sed -i $file -e "$ s/#endif.*/\n#endif \/\/ $guard/"
- # Removes redundant \n added before, if they weren't needed.
- sed -i $file -e "/^$/N;/^\n$/D"
-
- # Check that first ifndef (should be header guard) is at the expected position.
- # If not it can mean we have some code before the guard that should be after.
- # "31" is the expected line with the copyright header.
- first_ifndef=$(grep -n -m 1 "ifndef" $file | sed 's/\([0-9]*\).*/\1/')
- if [[ "$first_ifndef" != "31" ]]; then
- files_invalid_guard+="$file\n"
- fi
-done
-
-if [[ ! -z "$files_invalid_guard" ]]; then
- echo -e "The following files were found to have potentially invalid header guard:\n"
- echo -e "$files_invalid_guard"
-fi
-
-diff=$(git diff --color)
-
-# If no diff has been generated all is OK, clean up, and exit.
-if [ -z "$diff" ] ; then
- printf "Files in this commit comply with the header guards formatting rules.\n"
- exit 0
-fi
-
-# A diff has been created, notify the user, clean up, and exit.
-printf "\n*** The following differences were found between the code "
-printf "and the header guards formatting rules:\n\n"
-echo "$diff"
-printf "\n*** Aborting, please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
-exit 1
diff --git a/misc/scripts/mypy.ini b/misc/scripts/mypy.ini
deleted file mode 100644
index c1ea695..0000000
--- a/misc/scripts/mypy.ini
+++ /dev/null
@@ -1,11 +0,0 @@
-[mypy]
-ignore_missing_imports = true
-disallow_any_generics = True
-pretty = True
-show_column_numbers = True
-warn_redundant_casts = True
-warn_return_any = True
-warn_unreachable = True
-
-namespace_packages = True
-explicit_package_bases = True
diff --git a/misc/scripts/mypy_check.sh b/misc/scripts/mypy_check.sh
deleted file mode 100755
index 2a06486..0000000
--- a/misc/scripts/mypy_check.sh
+++ /dev/null
@@ -1,6 +0,0 @@
-#!/usr/bin/env bash
-
-set -uo pipefail
-
-echo -e "Python: mypy static analysis..."
-mypy --config-file=./misc/scripts/mypy.ini .